%define anolis_release 1
%global         majorminor 1.0
%global         _gobject_introspection  1.31.1

%bcond_with extras

Name:           gstreamer1-plugins-bad-free
Version:        1.22.6
Release:        %{anolis_release}%{?dist}
Summary:        GStreamer streaming media framework "bad" plugins

License:        LGPLv2+ and LGPLv2
URL:            http://gstreamer.freedesktop.org/
Source0:        https://gstreamer.freedesktop.org/src/gst-plugins-bad/gst-plugins-bad-%{version}.tar.xz
Source1:        gst-p-bad-cleanup.sh

Patch1001:      1001-add-infos-for-appstream.patch

BuildRequires:  gcc-c++ meson >= 0.48.0
BuildRequires:  check
BuildRequires:  glslc

BuildRequires:  bluez-libs-devel >= 5.0
BuildRequires:  bzip2-devel
BuildRequires:  exempi-devel
BuildRequires:  fdk-aac-free-devel
BuildRequires:  gettext-devel
BuildRequires:  gtk3-devel >= 3.4
BuildRequires:  gsm-devel
BuildRequires:  gstreamer1-devel >= %{version}
BuildRequires:  gstreamer1-plugins-base-devel >= %{version}
BuildRequires:  gnutls-devel
BuildRequires:  gobject-introspection-devel >= %{_gobject_introspection}
BuildRequires:  jasper-devel
BuildRequires:  lcms2-devel
BuildRequires:  libdrm-devel
BuildRequires:  libdvdnav-devel
BuildRequires:  libexif-devel
BuildRequires:  libgcrypt-devel
BuildRequires:  librsvg2-devel
BuildRequires:  libsndfile-devel
BuildRequires:  libsrtp-devel
BuildRequires:  libwebp-devel
BuildRequires:  libXt-devel
BuildRequires:  mesa-libEGL-devel
BuildRequires:  mesa-libGL-devel
BuildRequires:  mesa-libGLES-devel
BuildRequires:  mesa-libGLU-devel
BuildRequires:  nettle-devel
BuildRequires:  openssl-devel
BuildRequires:  opus-devel
BuildRequires:  orc-devel
BuildRequires:  soundtouch-devel
BuildRequires:  vulkan-devel
BuildRequires:  wavpack-devel
BuildRequires:  wayland-devel
BuildRequires:  wayland-protocols-devel
BuildRequires:  webrtc-audio-processing-devel

BuildRequires:  pkgconfig(gudev-1.0)
BuildRequires:  pkgconfig(libusb-1.0)

%if %{with extras}

BuildRequires:  fluidsynth-devel
BuildRequires:  game-music-emu-devel
BuildRequires:  json-glib-devel
BuildRequires:  ladspa-devel
BuildRequires:  libaom-devel
BuildRequires:  libass-devel
BuildRequires:  libbs2b-devel >= 3.1.0
BuildRequires:  libchromaprint-devel
BuildRequires:  libcurl-devel
BuildRequires:  libkate-devel
BuildRequires:  liblrdf-devel
BuildRequires:  libmicrodns-devel
BuildRequires:  libmodplug-devel
BuildRequires:  libnice-devel
BuildRequires:  libopenmpt-devel
BuildRequires:  libssh2-devel
BuildRequires:  libvdpau-devel
BuildRequires:  libxml2-devel
BuildRequires:  lilv-devel
BuildRequires:  openal-soft-devel
BuildRequires:  openjpeg2-devel
BuildRequires:  OpenEXR-devel
BuildRequires:  qrencode-devel
BuildRequires:  srt-devel
BuildRequires:  wildmidi-devel
BuildRequires:  zbar-devel
BuildRequires:  zvbi-devel

BuildRequires:  pkgconfig(ldacBT-enc)
BuildRequires:  pkgconfig(libva) >= 1.6
BuildRequires:  pkgconfig(libva-drm) >= 1.6
BuildRequires:  pkgconfig(spandsp) >= 0.0.6
%endif

Obsoletes: gstreamer1-plugins-bad-nonfree < 1.16.1-2

Provides: gst-transcoder = 1.16.0-4
Obsoletes: gst-transcoder < 1.16.0-4

%description
%{name} is a set of open-source plugins for the GStreamer multimedia framework.
These plugins are designed to handle a wide range of audio and video formats,
including some formats that are considered "bad" or "restricted" due to patent
or licensing issues.

The plugins in this package include support for popular multimedia formats like
MP3, AAC, and H.264. They also include plugins for handling DVD playback and
various streaming protocols.

While some of these plugins are considered "bad" due to their legal status,
the GStreamer community has worked to ensure that these plugins are free from
any proprietary code or dependencies. This ensures that they are fully
compatible with open-source software and can be used freely without any legal
issues.

%if %{with extras}
%package extras
Summary:         Extra GStreamer "bad" plugins (less often used "bad" plugins)
Requires:        %{name} = %{version}-%{release}

%description extras
%{name} is a set of open-source plugins for the GStreamer multimedia framework.
These plugins are designed to handle a wide range of audio and video formats,
including some formats that are considered "bad" or "restricted" due to patent
or licensing issues.

gstreamer-plugins-bad contains plug-ins that aren't tested well enough,
or the code is not of good enough quality.

This package (%{name}-extras) contains
extra "bad" plugins for sources (mythtv), sinks (fbdev) and
effects (pitch) which are not used very much and require additional
libraries to be installed.

%package zbar
Summary:         GStreamer "bad" plugins zbar plugin
Requires:        %{name} = %{version}-%{release}

%description zbar
%{name} is a set of open-source plugins for the GStreamer multimedia framework.
These plugins are designed to handle a wide range of audio and video formats,
including some formats that are considered "bad" or "restricted" due to patent
or licensing issues.

gstreamer-plugins-bad contains plug-ins that aren't tested well enough,
or the code is not of good enough quality.

This package (%{name}-zbar) contains the zbar
plugin which allows decode bar codes.

%package fluidsynth
Summary:         GStreamer "bad" plugins fluidsynth plugin
Requires:        %{name} = %{version}-%{release}
Requires:        soundfont2-default

%description fluidsynth
%{name} is a set of open-source plugins for the GStreamer multimedia framework.
These plugins are designed to handle a wide range of audio and video formats,
including some formats that are considered "bad" or "restricted" due to patent
or licensing issues.

gstreamer-plugins-bad contains plug-ins that aren't tested well enough,
or the code is not of good enough quality.

This package (%{name}-fluidsynth) contains the fluidsynth
plugin which allows playback of midi files.


%package wildmidi
Summary:         GStreamer "bad" plugins wildmidi plugin
Requires:        %{name} = %{version}-%{release}

%description wildmidi
%{name} is a set of open-source plugins for the GStreamer multimedia framework.
These plugins are designed to handle a wide range of audio and video formats,
including some formats that are considered "bad" or "restricted" due to patent
or licensing issues.

gstreamer-plugins-bad contains plug-ins that aren't tested well enough,
or the code is not of good enough quality.

This package (%{name}-wildmidi) contains the wildmidi
plugin which allows playback of midi files.
%endif


%package devel
Summary:        Development files for the GStreamer media framework "bad" plug-ins
Requires:       %{name} = %{version}-%{release}
Requires:       gstreamer1-plugins-base-devel

Provides: gst-transcoder-devel = 1.16.0-4
Obsoletes: gst-transcoder-devel < 1.16.0-4


%description devel
%{name} is a set of open-source plugins for the GStreamer multimedia framework.
These plugins are designed to handle a wide range of audio and video formats,
including some formats that are considered "bad" or "restricted" due to patent
or licensing issues.

This package contains the development files for the plug-ins that
aren't tested well enough, or the code is not of good enough quality.

%package doc
Summary:        Documentation for the GStreamer media framework "bad" plug-ins
Buildarch:      noarch
Requires:       %{name} = %{version}-%{release}

%description doc
%{name} is a set of open-source plugins for the GStreamer multimedia framework.
These plugins are designed to handle a wide range of audio and video formats,
including some formats that are considered "bad" or "restricted" due to patent
or licensing issues.

This package contains the documentation for the plug-ins.


%prep
%autosetup -p1 -n gst-plugins-bad-%{version}

%build
%meson \
    -D package-name="GStreamer-plugins-bad package" \
    -D package-origin="http://openanolis.cn" \
    -D tests=disabled \
    -D doc=disabled -D magicleap=disabled -D msdk=disabled \
    -D dts=disabled -D faac=disabled -D faad=disabled \
    -D mpeg2enc=disabled -D mplex=disabled \
    -D neon=disabled -D rtmp=disabled \
    -D flite=disabled -D sbc=disabled -D opencv=disabled \
    -D voamrwbenc=disabled -D x265=disabled \
    -D dvbsuboverlay=disabled -D dvdspu=disabled -D siren=disabled \
    -D opensles=disabled -D tinyalsa=disabled \
    -D wasapi=disabled -D wasapi2=disabled -D avtp=disabled \
    -D dc1394=disabled -D directfb=disabled -D iqa=disabled \
    -D libde265=disabled -D musepack=disabled -D openni2=disabled \
    -D svthevcenc=disabled -D voaacenc=disabled \
    -D zxing=disabled -D wpe=disabled -D x11=disabled \
    -D openh264=disabled -D gs=disabled -D isac=disabled \
    -D onnx=disabled -D openaptx=disabled -Dgpl=enabled \
    -D amfcodec=disabled -D directshow=disabled -D qsv=disabled \
    %{!?with_extras:-D assrender=disabled -D bs2b=disabled } \
    %{!?with_extras:-D chromaprint=disabled -D d3dvideosink=disabled } \
    %{!?with_extras:-D curl=disabled -D curl-ssh2=disabled } \
    %{!?with_extras:-D directsound=disabled -D dts=disabled } \
    %{!?with_extras:-D dts=disabled } \
    %{!?with_extras:-D fbdev=disabled -D decklink=disabled } \
    %{!?with_extras:-D fluidsynth=disabled -D openexr=disabled } \
    %{!?with_extras:-D gme=disabled -D lv2=disabled } \
    %{!?with_extras:-D ldac=disabled } 		\
    %{!?with_extras:-D ladspa=disabled } \
    %{!?with_extras:-D modplug=disabled } \
    %{!?with_extras:-D spandsp=disabled -D va=disabled } \
    %{!?with_extras:-D teletext=disabled -D srt=disabled } \
    %{!?with_extras:-D ttml=disabled -D kate=disabled } \
    %{!?with_extras:-D openal=disabled } \
    %{!?with_extras:-D opencv=disabled -D openjpeg=disabled } \
    %{!?with_extras:-D openmpt=disabled -D microdns=disabled } \
    %{!?with_extras:-D qroverlay=disabled } 		\
    %{!?with_extras:-D webrtc=disabled -D aom=disabled } \
    %{!?with_extras:-D wildmidi=disabled -D zbar=disabled } \
    %{nil}

%meson_build

%install
%meson_install

mkdir -p $RPM_BUILD_ROOT%{_metainfodir}
install -m 0644 -p gstreamer-bad-free.appdata.xml $RPM_BUILD_ROOT%{_metainfodir}

%find_lang gst-plugins-bad-%{majorminor}

# delete files that are not needed
rm $RPM_BUILD_ROOT%{_bindir}/playout

%files -f gst-plugins-bad-%{majorminor}.lang
%license COPYING
%doc AUTHORS README.md REQUIREMENTS

%{_metainfodir}/*.appdata.xml
%{_bindir}/gst-transcoder-%{majorminor}

# package presets
%dir %{_datadir}/gstreamer-%{majorminor}/presets/
%{_datadir}/gstreamer-%{majorminor}/presets/*.prs
%{_datadir}/gstreamer-%{majorminor}/encoding-profiles/device/*.gep
%{_datadir}/gstreamer-%{majorminor}/encoding-profiles/file-extension/*.gep
%{_datadir}/gstreamer-%{majorminor}/encoding-profiles/online-services/*.gep

%{_libdir}/libgst*.so.*

%{_libdir}/girepository-%{majorminor}/*-%{majorminor}.typelib

# Plugins without external dependencies
%{_libdir}/gstreamer-%{majorminor}/libgstaccurip.so
%{_libdir}/gstreamer-%{majorminor}/libgstadpcmdec.so
%{_libdir}/gstreamer-%{majorminor}/libgstadpcmenc.so
%{_libdir}/gstreamer-%{majorminor}/libgstaiff.so
%{_libdir}/gstreamer-%{majorminor}/libgstasfmux.so
%{_libdir}/gstreamer-%{majorminor}/libgstaudiobuffersplit.so
%{_libdir}/gstreamer-%{majorminor}/libgstaudiofxbad.so
%{_libdir}/gstreamer-%{majorminor}/libgstaudiolatency.so
%{_libdir}/gstreamer-%{majorminor}/libgstaudiomixmatrix.so
%{_libdir}/gstreamer-%{majorminor}/libgstaudiovisualizers.so
%{_libdir}/gstreamer-%{majorminor}/libgstautoconvert.so
%{_libdir}/gstreamer-%{majorminor}/libgstbayer.so
%{_libdir}/gstreamer-%{majorminor}/libgstcamerabin.so
%{_libdir}/gstreamer-%{majorminor}/libgstcodecalpha.so
%{_libdir}/gstreamer-%{majorminor}/libgstcodectimestamper.so
%{_libdir}/gstreamer-%{majorminor}/libgstcoloreffects.so
%{_libdir}/gstreamer-%{majorminor}/libgstdash.so
%{_libdir}/gstreamer-%{majorminor}/libgstdvbsubenc.so
%{_libdir}/gstreamer-%{majorminor}/libgstfaceoverlay.so
%if %{with extras}
%{_libdir}/gstreamer-%{majorminor}/libgstfbdevsink.so
%endif

%{_libdir}/gstreamer-%{majorminor}/libgstfdkaac.so
%{_libdir}/gstreamer-%{majorminor}/libgstfestival.so
%{_libdir}/gstreamer-%{majorminor}/libgstfieldanalysis.so
%{_libdir}/gstreamer-%{majorminor}/libgstfreeverb.so
%{_libdir}/gstreamer-%{majorminor}/libgstfrei0r.so
%{_libdir}/gstreamer-%{majorminor}/libgstgaudieffects.so
%{_libdir}/gstreamer-%{majorminor}/libgstgdp.so
%{_libdir}/gstreamer-%{majorminor}/libgstgeometrictransform.so
%{_libdir}/gstreamer-%{majorminor}/libgstlegacyrawparse.so
%{_libdir}/gstreamer-%{majorminor}/libgstid3tag.so
%{_libdir}/gstreamer-%{majorminor}/libgstipcpipeline.so
%{_libdir}/gstreamer-%{majorminor}/libgstinter.so
%{_libdir}/gstreamer-%{majorminor}/libgstinterlace.so
%{_libdir}/gstreamer-%{majorminor}/libgstivfparse.so
%{_libdir}/gstreamer-%{majorminor}/libgstivtc.so
%{_libdir}/gstreamer-%{majorminor}/libgstjp2kdecimator.so
%{_libdir}/gstreamer-%{majorminor}/libgstjpegformat.so
%{_libdir}/gstreamer-%{majorminor}/libgstmidi.so
%{_libdir}/gstreamer-%{majorminor}/libgstmpegpsdemux.so
%{_libdir}/gstreamer-%{majorminor}/libgstmpegtsdemux.so
%{_libdir}/gstreamer-%{majorminor}/libgstmpegpsmux.so
%{_libdir}/gstreamer-%{majorminor}/libgstmpegtsmux.so
%{_libdir}/gstreamer-%{majorminor}/libgstmxf.so
%{_libdir}/gstreamer-%{majorminor}/libgstnetsim.so
%{_libdir}/gstreamer-%{majorminor}/libgstpcapparse.so
%{_libdir}/gstreamer-%{majorminor}/libgstpnm.so
%{_libdir}/gstreamer-%{majorminor}/libgstproxy.so
%{_libdir}/gstreamer-%{majorminor}/libgstremovesilence.so
%{_libdir}/gstreamer-%{majorminor}/libgstresindvd.so
%{_libdir}/gstreamer-%{majorminor}/libgstrfbsrc.so
%{_libdir}/gstreamer-%{majorminor}/libgstrsvg.so
%{_libdir}/gstreamer-%{majorminor}/libgstrtmp2.so
%{_libdir}/gstreamer-%{majorminor}/libgstrtpmanagerbad.so
%{_libdir}/gstreamer-%{majorminor}/libgstrtponvif.so
%{_libdir}/gstreamer-%{majorminor}/libgstsdpelem.so
%{_libdir}/gstreamer-%{majorminor}/libgstsegmentclip.so
%{_libdir}/gstreamer-%{majorminor}/libgstshm.so
%{_libdir}/gstreamer-%{majorminor}/libgstsmooth.so
%{_libdir}/gstreamer-%{majorminor}/libgstsmoothstreaming.so
%{_libdir}/gstreamer-%{majorminor}/libgstspeed.so
%{_libdir}/gstreamer-%{majorminor}/libgstsubenc.so
%{_libdir}/gstreamer-%{majorminor}/libgstswitchbin.so
%{_libdir}/gstreamer-%{majorminor}/libgsttimecode.so
%{_libdir}/gstreamer-%{majorminor}/libgsttranscode.so
%{_libdir}/gstreamer-%{majorminor}/libgstuvch264.so
%{_libdir}/gstreamer-%{majorminor}/libgstvideofiltersbad.so
%{_libdir}/gstreamer-%{majorminor}/libgstvideoframe_audiolevel.so
%{_libdir}/gstreamer-%{majorminor}/libgstvideoparsersbad.so
%{_libdir}/gstreamer-%{majorminor}/libgstvideosignal.so
%{_libdir}/gstreamer-%{majorminor}/libgstvmnc.so
%{_libdir}/gstreamer-%{majorminor}/libgsty4mdec.so

# System (Linux) specific plugins
%{_libdir}/gstreamer-%{majorminor}/libgstdvb.so
%{_libdir}/gstreamer-%{majorminor}/libgstv4l2codecs.so

# Plugins with external dependencies

%{_libdir}/gstreamer-%{majorminor}/libgstaes.so
%{_libdir}/gstreamer-%{majorminor}/libgstbluez.so
%{_libdir}/gstreamer-%{majorminor}/libgstbz2.so
%{_libdir}/gstreamer-%{majorminor}/libgstclosedcaption.so
%{_libdir}/gstreamer-%{majorminor}/libgstcolormanagement.so
%{_libdir}/gstreamer-%{majorminor}/libgstdtls.so
%{_libdir}/gstreamer-%{majorminor}/libgsthls.so
%{_libdir}/gstreamer-%{majorminor}/libgstgsm.so
%{_libdir}/gstreamer-%{majorminor}/libgstgtkwayland.so
%{_libdir}/gstreamer-%{majorminor}/libgstkms.so
%{_libdir}/gstreamer-%{majorminor}/libgstnvcodec.so
%{_libdir}/gstreamer-%{majorminor}/libgstopusparse.so
%{_libdir}/gstreamer-%{majorminor}/libgstrist.so
%{_libdir}/gstreamer-%{majorminor}/libgstsctp.so
%{_libdir}/gstreamer-%{majorminor}/libgstsndfile.so
%{_libdir}/gstreamer-%{majorminor}/libgstsoundtouch.so
%{_libdir}/gstreamer-%{majorminor}/libgstsrtp.so
%{_libdir}/gstreamer-%{majorminor}/libgstvulkan.so
%{_libdir}/gstreamer-%{majorminor}/libgstwaylandsink.so
%{_libdir}/gstreamer-%{majorminor}/libgstwebp.so
%{_libdir}/gstreamer-%{majorminor}/libgstwebrtcdsp.so
%if %{with extras}
%{_libdir}/gstreamer-%{majorminor}/libgstwebrtc.so
%{_libdir}/gstreamer-%{majorminor}/libgstlv2.so
%{_libdir}/gstreamer-%{majorminor}/libgstttmlsubs.so
%endif

#debugging plugin
%{_libdir}/gstreamer-%{majorminor}/libgstdebugutilsbad.so


%if %{with extras}
%files extras
# Plugins with external dependencies
%{_libdir}/gstreamer-%{majorminor}/libgstaom.so
%{_libdir}/gstreamer-%{majorminor}/libgstassrender.so
%{_libdir}/gstreamer-%{majorminor}/libgstbs2b.so
%{_libdir}/gstreamer-%{majorminor}/libgstchromaprint.so
%{_libdir}/gstreamer-%{majorminor}/libgstcurl.so
%{_libdir}/gstreamer-%{majorminor}/libgstdecklink.so
%{_libdir}/gstreamer-%{majorminor}/libgstgme.so
%{_libdir}/gstreamer-%{majorminor}/libgstkate.so
%{_libdir}/gstreamer-%{majorminor}/libgstladspa.so
%{_libdir}/gstreamer-%{majorminor}/libgstldac.so
%{_libdir}/gstreamer-%{majorminor}/libgstmicrodns.so
%{_libdir}/gstreamer-%{majorminor}/libgstmodplug.so
%{_libdir}/gstreamer-%{majorminor}/libgstopenal.so
%{_libdir}/gstreamer-%{majorminor}/libgstopenexr.so
%{_libdir}/gstreamer-%{majorminor}/libgstopenjpeg.so
%{_libdir}/gstreamer-%{majorminor}/libgstopenmpt.so
%{_libdir}/gstreamer-%{majorminor}/libgstqroverlay.so
%{_libdir}/gstreamer-%{majorminor}/libgstspandsp.so
%{_libdir}/gstreamer-%{majorminor}/libgstsrt.so
%{_libdir}/gstreamer-%{majorminor}/libgstteletext.so

%files zbar
# Plugins with external dependencies
%{_libdir}/gstreamer-%{majorminor}/libgstzbar.so

%files fluidsynth
# Plugins with external dependencies
%{_libdir}/gstreamer-%{majorminor}/libgstfluidsynthmidi.so

%files wildmidi
# Plugins with external dependencies
%{_libdir}/gstreamer-%{majorminor}/libgstwildmidi.so
%endif

%files devel
%{_datadir}/gir-1.0/*.gir
%{_libdir}/libgst*.so
%{_includedir}/gstreamer-%{majorminor}/gst/*

# pkg-config files
%{_libdir}/pkgconfig/gstreamer-*.pc

%files doc
%doc ChangeLog NEWS README.static-linking
%doc docs/*


%changelog
* Wed Sep 27 2023 Funda Wang <fundawang@yeah.net> - 1.22.6-1
- New version 1.22.6

* Sun Jun 25 2023 Funda Wang <fundawang@yeah.net> - 1.22.4-1
- New version 1.22.4

* Mon May 22 2023 Funda Wang <fundawang@yeah.net> - 1.22.3-1
- New version 1.22.3

* Sat Apr 15 2023 Funda Wang <fundawang@yeah.net> - 1.22.2-1
- New version 1.22.2

* Wed Apr 12 2023 Kun(llfl) <llfl@linux.alibaba.com> - 1.22.1-2
- optimize spec file

* Tue Mar 7 2023 Funda Wang <fundawang@yeah.net> - 1.22.1-1
- New version 1.22.1

* Fri Feb 3 2023 Funda Wang <fundawang@yeah.net> - 1.22.0-1
- New version 1.22.0

* Tue Dec 20 2022 Funda Wang <fundawang@yeah.net> - 1.20.5-1
- New version 1.20.5

* Fri Nov 18 2022 Funda Wang <fundawang@yeah.net> - 1.20.4-1
- New version 1.20.4

* Tue May 17 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1.20.1-2
- rebuild without extras

* Mon Apr 11 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1.20.1-1
- init from upstream
